/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is part of dcm4che, an implementation of DICOM(TM) in
 * Java(TM), available at http://sourceforge.net/projects/dcm4che.
 *
 * The Initial Developer of the Original Code is
 * TIANI Medgraph AG.
 * Portions created by the Initial Developer are Copyright (C) 2003-2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Gunter Zeilinger <gunter.zeilinger@tiani.com>
 * Franz Willer <franz.willer@gwi-ag.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

package org.dcm4chex.archive.ejb.interfaces;

/**
 * @author gunter.zeilinger@tiani.com
 * @version $Revision: 2117 $ $Date: 2005-12-02 15:54:05 +0100 (Fri, 02 Dec
 *          2005) $
 * @since 07.12.2004
 */
public class MD5
{
	public static byte[] toBytes(String s)
	{
		if (s == null)
			return null;
		char[] md5Hex = s.toCharArray();
		byte[] md5 = new byte[16];
		for (int i = 0; i < md5.length; i++)
		{
			md5[i] = (byte) ((Character.digit(md5Hex[i << 1], 16) << 4) + Character
					.digit(md5Hex[(i << 1) + 1], 16));
		}
		return md5;
	}

	public static String toString(byte[] md5)
	{
		if (md5 == null)
			return null;
		if (md5.length != 16)
		{
			throw new IllegalArgumentException("md5.length=" + md5.length);
		}
		char[] md5Hex = new char[32];
		for (int i = 0; i < md5.length; i++)
		{
			md5Hex[i << 1] = Character.forDigit((md5[i] >> 4) & 0xf, 16);
			md5Hex[(i << 1) + 1] = Character.forDigit(md5[i] & 0xf, 16);
		}
		return new String(md5Hex);
	}
}
