/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * AEs.java
 *
 * Created on May 27, 2010, 12:31:38 PM
 */

package org.nrg.xnat.gui;

import java.util.ListIterator;
import java.util.Vector;
import javax.swing.JFrame;
import org.nrg.xnat.env.GatewayEnvironment;

/**
 *
 * @author Aditya Siram
 */
public class AEs extends javax.swing.JFrame {
    private final GatewayEnvironment env;
    private final ChildManager c;
    private final DefaultChildManager change_window;
    private final DefaultChildManager add_ae_window;
    private final DefaultChildManager edit_ae_window;
    private final UpdateGateway gateway_controller;
    private final UpdateAETable table_controller;
    private final Vector<JFrame> children;
    /** Creates new form AEs */
    public AEs(GatewayEnvironment env, ChildManager c) {
        this.env = env;
        children = new Vector<JFrame>();
        initComponents();
        this.c = c;
        change_window = new DefaultChildManager(this.change_button);
        add_ae_window = new DefaultChildManager(this.add_ae_button);
        edit_ae_window = new DefaultChildManager(this.edit_ae_button);
        this.my_ae_title.setText(env.get_calledae_title());
        this.my_listening_port.setText(Integer.toString(env.get_listening_port()));
        gateway_controller = new UpdateGateway(this.my_ae_title, this.my_listening_port, env);
        table_controller = new UpdateAETable(this.ae_properties_table, env);
        table_controller.initialize();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        my_ae_title = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        my_listening_port = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        ae_properties_table = new javax.swing.JTable();
        change_button = new javax.swing.JButton();
        add_ae_button = new javax.swing.JButton();
        delete_ae_button = new javax.swing.JButton();
        edit_ae_button = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        close_button = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Local/Remote AE Configuration");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jLabel1.setText("AE Title:");

        my_ae_title.setText("<uninitialized>");

        jLabel3.setText("Listening Port:");

        my_listening_port.setText("<uninitialized>");

        jLabel2.setText("Gateway Settings");

        jLabel4.setText("Remote Devices");

        ae_properties_table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null}
            },
            new String [] {
                "Name", "AE Title"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(ae_properties_table);

        change_button.setText("Change");
        change_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                change_buttonMousePressed(evt);
            }
        });
        change_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                change_buttonActionPerformed(evt);
            }
        });

        add_ae_button.setText("Add");
        add_ae_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                add_ae_buttonMousePressed(evt);
            }
        });

        delete_ae_button.setText("Delete");
        delete_ae_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                delete_ae_buttonMousePressed(evt);
            }
        });

        edit_ae_button.setText("Edit");
        edit_ae_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                edit_ae_buttonMousePressed(evt);
            }
        });

        close_button.setText("Close");
        close_button.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                close_buttonMousePressed(evt);
            }
        });

        jLabel5.setText("(only devices on this list will be able to retrieve studies)");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel3))
                        .addGap(27, 27, 27)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(my_listening_port)
                            .addComponent(my_ae_title)))
                    .addComponent(change_button)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(143, 143, 143)
                        .addComponent(jLabel4)))
                .addContainerGap(220, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(155, Short.MAX_VALUE)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(139, 139, 139))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 375, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(close_button, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(delete_ae_button, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(edit_ae_button, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(add_ae_button, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jLabel5)
                .addContainerGap(110, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(my_ae_title))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(my_listening_port))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(change_button)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(add_ae_button)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(delete_ae_button)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(edit_ae_button)
                        .addGap(88, 88, 88)
                        .addComponent(close_button))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void change_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_change_buttonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_change_buttonActionPerformed

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        c.remove_from_child_count();
        ListIterator l = this.children.listIterator();
        while(l.hasNext()) {
            JFrame j = (JFrame) l.next();
            if (j != null) {
                j.dispose();
            }
        }
    }//GEN-LAST:event_formWindowClosed

    private void close_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_close_buttonMousePressed
        this.dispose();
    }//GEN-LAST:event_close_buttonMousePressed

    private void add_ae_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_add_ae_buttonMousePressed
        if (this.add_ae_button.isEnabled()) {
            this.add_ae_window.add_to_child_count();
            final AddAE _a = new AddAE(table_controller,add_ae_window);
            this.children.add(_a);
            java.awt.EventQueue.invokeLater(new Runnable() {
                public void run() {
                    _a.setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_add_ae_buttonMousePressed

    private void edit_ae_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_edit_ae_buttonMousePressed
        if (this.edit_ae_button.isEnabled()) {
            if (table_controller.get_selected_name() != null) {
                this.edit_ae_window.add_to_child_count();
                final EditAE _a = new EditAE(table_controller, edit_ae_window);
                this.children.add(_a);
                java.awt.EventQueue.invokeLater(new Runnable() {
                    public void run() {
                        _a.setVisible(true);
                    }
                });}
        }
    }//GEN-LAST:event_edit_ae_buttonMousePressed

    private void change_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_change_buttonMousePressed
        if (this.change_button.isEnabled()) {
            this.change_window.add_to_child_count();
            final GatewayAESettings s = new GatewayAESettings(env,gateway_controller,change_window);
            this.children.add(s);
            java.awt.EventQueue.invokeLater(new Runnable() {
                public void run() {
                    s.setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_change_buttonMousePressed

    private void delete_ae_buttonMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_delete_ae_buttonMousePressed
        this.table_controller.delete_current_selection();
    }//GEN-LAST:event_delete_ae_buttonMousePressed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton add_ae_button;
    private javax.swing.JTable ae_properties_table;
    private javax.swing.JButton change_button;
    private javax.swing.JButton close_button;
    private javax.swing.JButton delete_ae_button;
    private javax.swing.JButton edit_ae_button;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel my_ae_title;
    private javax.swing.JLabel my_listening_port;
    // End of variables declaration//GEN-END:variables

}
